import random
random.seed (1234567)

MaxN = 10000
MaxM = 100000
MaxL = 10000

test = 9

def out ():
	global test
	print 'Test %02d' % test
	global n, m, x, y, b, e, l
	assert (n <= MaxN)
	assert (m <= MaxM)
	f = open ('%02d' % test, 'w')
	f.write ('%d %d\n' % (n, m))
	f.write ('%d %d\n' % (x + 1, y + 1))
	for i in range (m):
		f.write ('%d %d %d\n' % (b[i] + 1, e[i] + 1, l[i]))
	f.close ()
	test += 1

def create (nnew):
	global n, m, x, y, b, e, l
	n = nnew
	m = 0
	x = random.randrange (n)
	y = random.randrange (n)
	b = []
	e = []
	l = []

def randomedges (k, lo, hi):
	global n, m, x, y, b, e, l
	for i in range (k):
		b.append (random.randrange (n))
		e.append (random.randrange (n))
		l.append (random.randrange (hi - lo + 1) + lo)
		m += 1

def chain (lo, hi):
	global n, m, x, y, b, e, l
	p = range (n)
	random.shuffle (p)
	for i in range (n - 1):
		b.append (p[i])
		e.append (p[i + 1])
		l.append (random.randrange (hi - lo + 1) + lo)
		m += 1

def chainxy (lo, hi):
	global n, m, x, y, b, e, l
	p = range (n)
	random.shuffle (p)
	x = p[0]
	y = p[n - 1]
	for i in range (n - 1):
		b.append (p[i])
		e.append (p[i + 1])
		l.append (random.randrange (hi - lo + 1) + lo)
		m += 1

create (8)
randomedges (10, 1, 10)
out ()

create (9)
randomedges (28, 6, 7)
out ()

create (10)
randomedges (20, 1, 100)
out ()

create (10)
randomedges (50, 1, 100)
out ()

create (20)
randomedges (60, 99, 100)
out ()

create (22)
chain (1, 120)
out ()

create (26)
chainxy (1, 120)
out ()

create (100)
randomedges (20, 1, 1000)
out ()

create (100)
randomedges (50, 1, 1000)
out ()

create (200)
randomedges (60, 990, 1000)
out ()

create (220)
chain (1, 1200)
out ()

create (260)
chainxy (1, 1200)
out ()

create (300)
randomedges (200, 1, 1000)
out ()

create (400)
randomedges (500, 1, 1000)
out ()

create (500)
randomedges (600, 990, 1000)
out ()

create (620)
chain (1, 1200)
chain (1, 1200)
chain (1, 1200)
chain (1, 1200)
chain (1, 1200)
out ()

create (780)
chainxy (1, 1200)
chain (1000, 1100)
chain (1000, 1100)
chain (1000, 1100)
chain (1000, 1100)
out ()

create (900)
randomedges (2000, 1, 1000)
out ()

create (800)
randomedges (5000, 1, 1000)
out ()

create (700)
randomedges (6000, 990, 1000)
out ()

create (950)
randomedges (1400, 9900, 9980)
chain (1, 120)
chain (1, 120)
chain (1, 120)
chain (1, 120)
chain (1, 120)
out ()

create (1000)
chainxy (10, 20)
randomedges (1400, 9900, 9980)
chain (8000, 9200)
chain (8000, 9200)
chain (8000, 9200)
chain (8000, 9200)
out ()

create (3000)
randomedges (20000, 1, 1000)
out ()

create (4000)
randomedges (50000, 1, 1000)
out ()

create (5000)
randomedges (60000, 990, 1000)
out ()

create (6200)
chainxy (9999, 10000)
randomedges (3, 9999, 10000)
out ()

create (10000)
chainxy (10000, 10000)
out ()

create (9000)
randomedges (21000, 999, 1000)
out ()

create (8000)
randomedges (53000, 999, 1000)
out ()

create (7000)
randomedges (66000, 1000, 10000)
out ()

create (9500)
randomedges (52004, 10000, 10000)
chain (110, 120)
chain (111, 120)
chain (112, 120)
chain (113, 120)
chain (114, 120)
out ()

create (10000)
chainxy (3, 4)
randomedges (50000, 9900, 10000)
chain (1000, 1000)
chain (2000, 2000)
chain (2000, 2000)
chain (3000, 3000)
out ()
