{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{18.12.2006 22:20
 Bug fixed 
  1)
  input:
     4
     AAAABBBB
  output:
     1
     A
  Was accepted by checker
}

uses
SysUtils, testlib;
const maxN:longint = 100000;
type ts = set of 'A'..'Z';
var msg,s : string;
    k,n : longint;
function checkSolution(var f:InStream;var r:integer):boolean;
var b : ts;
    z : string;
    i,j,l : longint;
begin
b := [];
r := f.ReadLongint;
z := f.ReadString;
if z<>'' then
  begin
  msg := 'line 1: tail='+z;
  Result := false;
  exit;
  end;
for i:=1 to r do
  begin
  z := f.ReadString;
  if Length(z)>1 then
    begin
    msg := Format('Length(z) > 1 at line %d: z=',[i+1]) + z;
    Result := false;
    exit;
    end;
  if not (z[1] in ['A'..'Z']) then
    begin
    msg := Format('not (z[1] in [''A''..''Z'']) at line %d: z=',[i+1]) + z;
    Result := false;
    exit;
    end;
  Include(b,z[1]);
  end;
j := 0;
for i:=1 to n do
  begin
  if not (s[i] in ['A'..'Z']) then
    QUIT(_FAIL,Format('Bad input at symbols %d: ',[i]) + s[i]);
  if s[i] in b then
    begin
    l := i - j - 1;
    if l >= k then
      begin
      msg := 'Uncovered sequence: ' + Copy(s,j+1,l);
      Result := false;
      exit;
      end;
    j := i;
    end
  end;
i := n+1;
l := i - j - 1;
if l >= k then
  begin
  msg := 'Uncovered sequence: ' + Copy(s,j+1,l);
  Result := false;
  exit;
  end;
Result := true;
end;
var na,no:integer;
begin
k := inf.ReadLongint;
s := inf.ReadString;
if s <> '' then QUIT(_FAIL,'Bad input at line 1: tail='+s);
s := inf.ReadString;
n := Length(s);
if n > maxN then
  QUIT(_FAIL,Format('Bad input line to long (%d symbols)',[n]));

if not checkSolution(ans,na) then
  QUIT(_FAIL,'Jury error:' + msg);
if not checkSolution(ouf,no) then
  QUIT(_WA,msg);
if na < no then
  QUIT(_WA,Format('Jury:%d Answer:%d',[na,no]));
if na > no then
  QUIT(_FAIL,Format('Jury:%d Answer:%d',[na,no]));

QUIT(_OK,'');
end.


