#include <cstdio>
#include <cassert>
#include <stack>
/* Test generator 
   based on problem Ouroboros Snake http://online-judge.uva.es/p/v100/10040.html
   (Euler circuit)
*/
using namespace std;
FILE *f;
int TestNo = 62;
void nextF()
{
char z[32];
sprintf(z,"%02d",TestNo++);
f = fopen(z,"w");
printf("%s: ",z);
}

void Test(int n,int k)
//n - number of letters
//k - path length
// answer for test = n (all letters must be included)
{
bool *b[32];
//vector<int> vv;
stack<int> s;
int i,j,N = 1;
for(i=1;i<k;i++) {N *= n;if (N >= 100000) return;}
if (N * n + (k-1) >= 100000) return;
nextF();printf("n=%d k=%d\n\n",n,k);
fprintf(f,"%d\n",k);fflush(stdout);
//fprintf(f,"%c",'A');
for(i=0;i<n;i++)
  {
  b[i] = new bool[N];
  for(j=0;j<N;j++) b[i][j] = false;
  }

s.push(0);
while(!s.empty())
  {
  int i,v = s.top();
  for(i=0;i<n;i++) if (!b[i][v])
    {
    s.push((v * n + i) % N);
    b[i][v] = true;
    break;
    }
  if (i == n)
    {
    s.pop();
    fprintf(f,"%c",'A' + (v % n));
    //vv.push_back(v);
    }
  }
for(i=1;i<k-1;i++) fprintf(f,"%c",'A');
fprintf(f,"\n");
for(i=0;i<n;i++) delete[] b[i];
fclose(f);
}


int main(void)
{
freopen("comments.txt","w",stdout);
Test(10,4);
Test(26,2);
Test(26,3);
return 0;
}
