@echo off
if "%1"=="" (set TEST=??) else (set TEST=%1)
set TASK=road
pushd ..
if NOT exist %TASK%_am_slow.class call cs %TASK%_am_slow.java
if NOT exist %TASK%_vv_fast.class call cs %TASK%_vv_fast.java
popd
for %%i in (%TEST%) do (
echo Test %%i:
pushd ..
copy tests\%%i %TASK%.in >nul
java.exe -ea -Xmx128M -Xss64M %TASK%_am_slow
copy %TASK%.out tests\%%i.b >nul
java.exe -ea -Xmx128M -Xss64M %TASK%_vv_fast
copy %TASK%.out tests\%%i.c >nul
popd
check %%i %%i.b %%i.a
check %%i %%i.c %%i.a
)
