program CStrings;

{$APPTYPE CONSOLE}
{$O+,Q-,R-}

uses
  SysUtils;

const
  MaxT = 1000000;
  MaxS = 1000000;

var
  T:Array[1..MaxT] Of Char;
  S:Array[1..MaxS] Of Char;
  P:Array[0..MaxS] Of Longint;
  TLen, SLen:Longint;

procedure CalcP;
var
  I, K:Longint;
begin
P[0] := 0; P[1] := 0;

For I := 2 To SLen Do Begin
  K := P[I - 1];
  While (K > 0) And (S[K + 1] <> S[I]) Do
    K := P[K];

  If K = 0 Then Begin
    If S[1] = S[I] Then
      P[I] := 1
    Else
      P[I] := 0;
  End Else
    P[I] := K + 1;
End;
end;

var
  C:Char;
  I, Pos, Co:Longint;
begin
AssignFile (input, 'strings.in');
ReSet (input);

TLen := 0; Read (input, C);
While (C <> Chr(13)) And (C <> Chr(10)) And (Not EOF(input)) Do Begin
  TLen := TLen + 1;
  T[TLen] := C;
  Read (input, C);
End;
Read (input, C);

SLen := 0; Read (input, C);
While (C <> Chr(13)) And (C <> Chr(10)) And (Not EOF(input)) Do Begin
  SLen := SLen + 1;
  S[SLen] := C;
  Read (input, C);
End;
Read (input, C);

Close (input);

CalcP;

Assign (output, 'strings.out');
ReWrite (output);

Pos := 0; Co := 0;

For I := 1 To TLen Do Begin
  If S[Pos + 1] = T[I] Then
    Pos := Pos + 1
  Else Begin
    While (S[Pos + 1] <> T[I]) And (Pos > 0) Do
      Pos := P[Pos];

    If S[Pos + 1] = T[I] Then
      Pos := Pos + 1;
  End;

  If Pos = SLen Then Begin
    Co := Co + 1;
    If Co = 1 Then
      Write (output, I - SLen + 1)
    Else
      Write (output, ' ', I - SLen + 1);
    Pos := P[Pos];
  End;
End;

If Co = 0 Then
  Write (output, 'none');
Writeln (output);

Close (output);
end.
